unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, system.Math, VclTee.TeeGDIPlus,
  VCLTee.Series, VCLTee.TeEngine, Vcl.ExtCtrls, VCLTee.TeeProcs, VCLTee.Chart,
  Vcl.StdCtrls, Vcl.Buttons;

type
  TForm1 = class(TForm)
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    BitBtn1: TBitBtn;
    CheckBox1: TCheckBox;
    Chart1: TChart;
    Series1: TLineSeries;
    Series2: TPointSeries;
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//---------------- Cauchy distribution ----------------------------
// x   ʒu
// x0  ϒl(l)
// g    Kz̃ЂƓňӖ̕Ul
//-----------------------------------------------------------------

// mx
function Probability(x, x0, g: double): double;
begin
  result := g / (sqr(x - x0) + sqr(g)) / pi;
end;

// ݐϕz()
function Cumulative(x, x0, g: double): double;
begin
  result := arctan((x - x0) / g) / pi + 1 / 2;
end;

// ݐϕztvZ
// ݐϕz̒lpXʒu̒l߂܂B
function arcCumulative(p, x0, g: double): double;
begin
  result := x0 + g * tan(pi * (p - 1 /2));
end;

// vZ
procedure TForm1.BitBtn1Click(Sender: TObject);
const
  n = 200;
var
  ch: integer;
  x0, x, g: double;
  f, fb: double;
  xmin, xmax, dx: double;
  col: Tcolor;
begin
  val(Labelededit1.Text, x0, ch);
  if ch <> 0 then begin
    application.MessageBox('Xo̒lɊԈႢ܂B','',0);
    exit;
  end;
  val(Labelededit2.Text, g, ch);
  if ch <> 0 then begin
    application.MessageBox('̒lɊԈႢ܂B','',0);
    exit;
  end;
  val(Labelededit3.Text, x, ch);
  if ch <> 0 then begin
    application.MessageBox('X̒lɊԈႢ܂B','',0);
    exit;
  end;
  Series1.Clear;
  Series2.Clear;
  chart1.Title.Text.Clear;
  if checkbox1.Checked = false then begin
    f := Probability(x, x0, g);
    chart1.Title.Text.Add('mx֐@f = ' + floatTostr(f));
    col := clRed;
    Series2.AddXY(x, f);
  end
  else begin
    f := Cumulative(x, x0, g);
    chart1.Title.Text.Add('ݐϕz֐ F = ' + floatTostr(f));
    fb := arcCumulative(f, x0, g);        // ݐϕztvZ Z
    col := clblue;
    Series2.AddXY(fb, f);
  end;
  xmin := -5;
  xmax := 5;
  if x < xmin + 1 then xmin := x - 1;
  if x > xmax - 1 then xmax := x + 1;
  dx := (xmax - xmin) / n;
  for ch := 0 to n do begin
    x := ch * dx + xmin;
    if checkbox1.Checked = false then f := Probability(x, x0, g)
                                 else f := Cumulative(x, x0, g);
    Series1.AddXY(x, f, '', col);
  end;
end;

end.
