unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, system.Math, Vcl.StdCtrls, Vcl.ExtCtrls,
  VclTee.TeeGDIPlus, VCLTee.Series, VCLTee.TeEngine, VCLTee.TeeProcs,
  VCLTee.Chart, Vcl.Buttons, system.UITypes;

type
  TForm1 = class(TForm)
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    RadioGroup1: TRadioGroup;
    BitBtn1: TBitBtn;
    Chart1: TChart;
    Series1: TLineSeries;
    Series2: TPointSeries;
    Series3: TFastLineSeries;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
// wz
// --------------- ݐϕz֐ ---------------------
// x    (0, )
// r ꐔ  r > 0
//---------------------------------------------------
function Exponential_Distribution(x, r: double): double;
begin
  if (x >= 0) and (r > 0) then result := 1 - exp(- x * r)
                          else result := 0;
end;

//---------------- mx֐----------------------
// x    (0, )
// r ꐔ  r > 0
//---------------------------------------------------
function Exponential_Density(x, r: double): double;
begin
  if (x >= 0) and (r > 0) then result := r * exp(- x * r)
                          else result := 0;
end;

// --------------- ݐϕzt֐ --------------------
// p p[Zg_  0`1
// r ꐔ  r > 0
//----------------------------------------------------
function arcExponential_Distribution(p, r: double): double;
begin
  if p >= 1 then begin
    result := infinity;
    exit;
  end;
  if (p < 1) and (p >= 0) and (r > 0) then begin
    result := ln(1 - p);
    result := - result / r;
  end
  else result := 0;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
const
  n = 200;
var
  x, r, p: double;
  dx, xx: double;
  ch : integer;
  f : double;
  max : double;
begin
  f := 0;
  x := 0;
  p := 0;
  val(labelededit1.Text, r, ch);
  if ch <> 0 then begin
    MessageDlg('ɕꐔɊԈႢ܂B', mtWarning, [mbOk], 0, mbOk);
    exit;
  end;
  if (RadioGroup1.ItemIndex = 0) or (RadioGroup1.ItemIndex = 1) then begin
    val(labelededit2.Text, x, ch);
    if ch <> 0 then begin
      MessageDlg('X ɊԈႢ܂B', mtWarning, [mbOk], 0, mbOk);
      exit;
    end;
  end;
  if RadioGroup1.ItemIndex = 2 then begin
    val(labelededit3.Text, p, ch);
    if ch <> 0 then begin
      MessageDlg('P p[Zg_ɊԈႢ܂B', mtWarning, [mbOk], 0, mbOk);
      exit;
    end;
  end;
  Chart1.Title.Clear;
  series1.Clear;
  series2.Clear;
  series3.Clear;
  case RadioGroup1.ItemIndex of
    0 : begin
          f := Exponential_Density(x, r);
          Chart1.Title.Text.Add('mx֐ f = ' + floatTostr(f));
          series2.AddXY(x, f);
        end;
    1 : begin
          f := Exponential_Distribution(x, r);
          Chart1.Title.Text.Add('ݐϕz֐ F = ' + floatTostr(f));
          series2.AddXY(x, f);
        end;
    2 : begin
          x := arcExponential_Distribution(p, r);
          Chart1.Title.Text.Add('p[Zg_ x = ' + floatTostr(x));
          if x < maxsingle then series2.AddXY(x, p);
        end;
  end;
  max := 5;
  if x = infinity then exit;
  if x > max - 1 then max := x + 1;
  dx := max / n;
  for ch := 0 to 200 do begin
    xx := ch * dx;
    case RadioGroup1.ItemIndex of
      0   : f := Exponential_Density(xx, r);
      1,2 : begin
              f := Exponential_Distribution(xx, r);
              if xx < x then begin
                series3.AddXY(xx, 0);
                series3.AddXY(xx, f);
                series3.AddXY(xx, 0);
              end;
            end;
    end;
    series1.AddXY(xx, f);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  with RadioGroup1 do begin
    Items.Add('mx֐');
    Items.Add('ݐϕz֐');
    Items.Add('p[Zg_');
    ItemIndex := 0;
  end;
end;

end.
