unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, system.Math, Vcl.StdCtrls, Vcl.ExtCtrls,
  VclTee.TeeGDIPlus, VCLTee.Series, VCLTee.TeEngine, VCLTee.TeeProcs,
  VCLTee.Chart, Vcl.Buttons, system.UITypes;

type
  TForm1 = class(TForm)
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    RadioGroup1: TRadioGroup;
    BitBtn1: TBitBtn;
    Chart1: TChart;
    Series1: TLineSeries;
    Series2: TPointSeries;
    Series3: TFastLineSeries;
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// WXeBbNz

//------------ ݐϕz֐ -----------------------------
// x (-,)
// u ʒu(location)
// s >0 ړx(scale)
//-------------------------------------------------------
function Logistic_Distribution(x, u, s: double): double;
begin
  if s <=0 then begin
    result := 0;
    exit;
  end;
  result := (tanh((x - u) / 2 / s) + 1) / 2;
end;

//------------ mx֐ -----------------------------
// x (-,)
// u ʒu(location)
// s >0 ړx(scale)
//-------------------------------------------------------
function Logistic_Density(x, u, s: double): double;
var
  umx, a, b: double;
begin
  if s <=0 then begin
    result := 0;
    exit;
  end;
  umx := (u - x) / s;
  a := exp(umx);
  b := 1 + exp(umx);
  b := s * b * b;
  result := a / b;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
const
  n = 200;
var
  u, s, x: double;
  dx, xx, f:  double;
  ch : integer;
  min, max: double;
begin
  val(labelededit1.Text, u, ch);
  if ch <> 0 then begin
    MessageDlg('ʈʒuɊԈႢ܂B', mtWarning, [mbOk], 0, mbOk);
    exit;
  end;
  val(labelededit2.Text, s, ch);
  if ch <> 0 then begin
    MessageDlg('s ړxɊԈႢ܂B', mtWarning, [mbOk], 0, mbOk);
    exit;
  end;
  val(labelededit3.Text, x, ch);
  if ch <> 0 then begin
    MessageDlg('x ɊԈႢ܂B', mtWarning, [mbOk], 0, mbOk);
    exit;
  end;
  Chart1.Title.Clear;
  series1.Clear;
  series2.Clear;
  series3.Clear;
  case RadioGroup1.ItemIndex of
    0 : begin
          f := Logistic_Density(x, u, s);
          Chart1.Title.Text.Add('mx֐ f = ' + floatTostr(f));
          series2.AddXY(x, f);
        end;
    1 : begin
          f := Logistic_Distribution(x, u, s);
          Chart1.Title.Text.Add('ݐϕz֐ F = ' + floatTostr(f));
          series2.AddXY(x, f);
        end;
  end;
  min := -5;
  max := 20;
  if x < min + 1 then min := x - 1;
  if x > max - 1 then max := x + 1;
  dx := (max - min) / n;
  for ch := 0 to n do begin
    xx := ch * dx + min;
    case RadioGroup1.ItemIndex of
      0 : f := Logistic_Density(xx, u, s);
      1 : begin
            f := Logistic_Distribution(xx, u, s);
            if xx < x then begin
              series3.AddXY(xx, 0);
              series3.AddXY(xx, f);
              series3.AddXY(xx, 0);
            end;
          end;
    end;
    series1.AddXY(xx, f);
  end;
end;

end.

